#ifndef COSMOPOLITAN_LIBC_SYSV_CONSTS__POSIX_H_
#define COSMOPOLITAN_LIBC_SYSV_CONSTS__POSIX_H_
#include "libc/runtime/symbolic.h"
#if !(__ASSEMBLER__ + __LINKER__ + 0)
COSMOPOLITAN_C_START_

extern const long _POSIX_ADVISORY_INFO;
extern const long _POSIX_AIO_LISTIO_MAX;
extern const long _POSIX_AIO_MAX;
extern const long _POSIX_ARG_MAX;
extern const long _POSIX_ASYNCHRONOUS_IO;
extern const long _POSIX_BARRIERS;
extern const long _POSIX_CHILD_MAX;
extern const long _POSIX_CHOWN_RESTRICTED;
extern const long _POSIX_CLOCKRES_MIN;
extern const long _POSIX_CLOCK_SELECTION;
extern const long _POSIX_CPUTIME;
extern const long _POSIX_DELAYTIMER_MAX;
extern const long _POSIX_FSYNC;
extern const long _POSIX_HOST_NAME_MAX;
extern const long _POSIX_IPV6;
extern const long _POSIX_JOB_CONTROL;
extern const long _POSIX_LINK_MAX;
extern const long _POSIX_LOGIN_NAME_MAX;
extern const long _POSIX_MAPPED_FILES;
extern const long _POSIX_MAX_CANON;
extern const long _POSIX_MAX_INPUT;
extern const long _POSIX_MEMLOCK;
extern const long _POSIX_MEMLOCK_RANGE;
extern const long _POSIX_MEMORY_PROTECTION;
extern const long _POSIX_MESSAGE_PASSING;
extern const long _POSIX_MONOTONIC_CLOCK;
extern const long _POSIX_MQ_OPEN_MAX;
extern const long _POSIX_MQ_PRIO_MAX;
extern const long _POSIX_NAME_MAX;
extern const long _POSIX_NGROUPS_MAX;
extern const long _POSIX_NO_TRUNC;
extern const long _POSIX_OPEN_MAX;
extern const long _POSIX_PATH_MAX;
extern const long _POSIX_PIPE_BUF;
extern const long _POSIX_RAW_SOCKETS;
extern const long _POSIX_READER_WRITER_LOCKS;
extern const long _POSIX_REALTIME_SIGNALS;
extern const long _POSIX_REGEXP;
extern const long _POSIX_RE_DUP_MAX;
extern const long _POSIX_RTSIG_MAX;
extern const long _POSIX_SAVED_IDS;
extern const long _POSIX_SEMAPHORES;
extern const long _POSIX_SEM_NSEMS_MAX;
extern const long _POSIX_SEM_VALUE_MAX;
extern const long _POSIX_SHARED_MEMORY_OBJECTS;
extern const long _POSIX_SHELL;
extern const long _POSIX_SIGQUEUE_MAX;
extern const long _POSIX_SPAWN;
extern const long _POSIX_SPIN_LOCKS;
extern const long _POSIX_SSIZE_MAX;
extern const long _POSIX_SS_REPL_MAX;
extern const long _POSIX_STREAM_MAX;
extern const long _POSIX_SYMLINK_MAX;
extern const long _POSIX_SYMLOOP_MAX;
extern const long _POSIX_THREADS;
extern const long _POSIX_THREAD_ATTR_STACKADDR;
extern const long _POSIX_THREAD_ATTR_STACKSIZE;
extern const long _POSIX_THREAD_CPUTIME;
extern const long _POSIX_THREAD_DESTRUCTOR_ITERATIONS;
extern const long _POSIX_THREAD_KEYS_MAX;
extern const long _POSIX_THREAD_PRIORITY_SCHEDULING;
extern const long _POSIX_THREAD_PROCESS_SHARED;
extern const long _POSIX_THREAD_SAFE_FUNCTIONS;
extern const long _POSIX_THREAD_THREADS_MAX;
extern const long _POSIX_TIMEOUTS;
extern const long _POSIX_TIMERS;
extern const long _POSIX_TIMER_MAX;
extern const long _POSIX_TRACE_EVENT_NAME_MAX;
extern const long _POSIX_TRACE_NAME_MAX;
extern const long _POSIX_TRACE_SYS_MAX;
extern const long _POSIX_TRACE_USER_EVENT_MAX;
extern const long _POSIX_TTY_NAME_MAX;
extern const long _POSIX_TZNAME_MAX;
extern const long _POSIX_V6_LP64_OFF64;
extern const long _POSIX_V7_LP64_OFF64;
extern const long _POSIX_VDISABLE;
extern const long _POSIX_VERSION;

COSMOPOLITAN_C_END_
#endif /* !(__ASSEMBLER__ + __LINKER__ + 0) */

#define _POSIX_ADVISORY_INFO         SYMBOLIC(_POSIX_ADVISORY_INFO)
#define _POSIX_AIO_LISTIO_MAX        SYMBOLIC(_POSIX_AIO_LISTIO_MAX)
#define _POSIX_AIO_MAX               SYMBOLIC(_POSIX_AIO_MAX)
#define _POSIX_ARG_MAX               SYMBOLIC(_POSIX_ARG_MAX)
#define _POSIX_ASYNCHRONOUS_IO       SYMBOLIC(_POSIX_ASYNCHRONOUS_IO)
#define _POSIX_BARRIERS              SYMBOLIC(_POSIX_BARRIERS)
#define _POSIX_CHILD_MAX             SYMBOLIC(_POSIX_CHILD_MAX)
#define _POSIX_CHOWN_RESTRICTED      SYMBOLIC(_POSIX_CHOWN_RESTRICTED)
#define _POSIX_CLOCKRES_MIN          SYMBOLIC(_POSIX_CLOCKRES_MIN)
#define _POSIX_CLOCK_SELECTION       SYMBOLIC(_POSIX_CLOCK_SELECTION)
#define _POSIX_CPUTIME               SYMBOLIC(_POSIX_CPUTIME)
#define _POSIX_DELAYTIMER_MAX        SYMBOLIC(_POSIX_DELAYTIMER_MAX)
#define _POSIX_FSYNC                 SYMBOLIC(_POSIX_FSYNC)
#define _POSIX_HOST_NAME_MAX         SYMBOLIC(_POSIX_HOST_NAME_MAX)
#define _POSIX_IPV6                  SYMBOLIC(_POSIX_IPV6)
#define _POSIX_JOB_CONTROL           SYMBOLIC(_POSIX_JOB_CONTROL)
#define _POSIX_LINK_MAX              SYMBOLIC(_POSIX_LINK_MAX)
#define _POSIX_LOGIN_NAME_MAX        SYMBOLIC(_POSIX_LOGIN_NAME_MAX)
#define _POSIX_MAPPED_FILES          SYMBOLIC(_POSIX_MAPPED_FILES)
#define _POSIX_MAX_CANON             SYMBOLIC(_POSIX_MAX_CANON)
#define _POSIX_MAX_INPUT             SYMBOLIC(_POSIX_MAX_INPUT)
#define _POSIX_MEMLOCK               SYMBOLIC(_POSIX_MEMLOCK)
#define _POSIX_MEMLOCK_RANGE         SYMBOLIC(_POSIX_MEMLOCK_RANGE)
#define _POSIX_MEMORY_PROTECTION     SYMBOLIC(_POSIX_MEMORY_PROTECTION)
#define _POSIX_MESSAGE_PASSING       SYMBOLIC(_POSIX_MESSAGE_PASSING)
#define _POSIX_MONOTONIC_CLOCK       SYMBOLIC(_POSIX_MONOTONIC_CLOCK)
#define _POSIX_MQ_OPEN_MAX           SYMBOLIC(_POSIX_MQ_OPEN_MAX)
#define _POSIX_MQ_PRIO_MAX           SYMBOLIC(_POSIX_MQ_PRIO_MAX)
#define _POSIX_NAME_MAX              SYMBOLIC(_POSIX_NAME_MAX)
#define _POSIX_NGROUPS_MAX           SYMBOLIC(_POSIX_NGROUPS_MAX)
#define _POSIX_NO_TRUNC              SYMBOLIC(_POSIX_NO_TRUNC)
#define _POSIX_OPEN_MAX              SYMBOLIC(_POSIX_OPEN_MAX)
#define _POSIX_PATH_MAX              SYMBOLIC(_POSIX_PATH_MAX)
#define _POSIX_PIPE_BUF              SYMBOLIC(_POSIX_PIPE_BUF)
#define _POSIX_RAW_SOCKETS           SYMBOLIC(_POSIX_RAW_SOCKETS)
#define _POSIX_READER_WRITER_LOCKS   SYMBOLIC(_POSIX_READER_WRITER_LOCKS)
#define _POSIX_REALTIME_SIGNALS      SYMBOLIC(_POSIX_REALTIME_SIGNALS)
#define _POSIX_REGEXP                SYMBOLIC(_POSIX_REGEXP)
#define _POSIX_RE_DUP_MAX            SYMBOLIC(_POSIX_RE_DUP_MAX)
#define _POSIX_RTSIG_MAX             SYMBOLIC(_POSIX_RTSIG_MAX)
#define _POSIX_SAVED_IDS             SYMBOLIC(_POSIX_SAVED_IDS)
#define _POSIX_SEMAPHORES            SYMBOLIC(_POSIX_SEMAPHORES)
#define _POSIX_SEM_NSEMS_MAX         SYMBOLIC(_POSIX_SEM_NSEMS_MAX)
#define _POSIX_SEM_VALUE_MAX         SYMBOLIC(_POSIX_SEM_VALUE_MAX)
#define _POSIX_SHARED_MEMORY_OBJECTS SYMBOLIC(_POSIX_SHARED_MEMORY_OBJECTS)
#define _POSIX_SHELL                 SYMBOLIC(_POSIX_SHELL)
#define _POSIX_SIGQUEUE_MAX          SYMBOLIC(_POSIX_SIGQUEUE_MAX)
#define _POSIX_SPAWN                 SYMBOLIC(_POSIX_SPAWN)
#define _POSIX_SPIN_LOCKS            SYMBOLIC(_POSIX_SPIN_LOCKS)
#define _POSIX_SSIZE_MAX             SYMBOLIC(_POSIX_SSIZE_MAX)
#define _POSIX_SS_REPL_MAX           SYMBOLIC(_POSIX_SS_REPL_MAX)
#define _POSIX_STREAM_MAX            SYMBOLIC(_POSIX_STREAM_MAX)
#define _POSIX_SYMLINK_MAX           SYMBOLIC(_POSIX_SYMLINK_MAX)
#define _POSIX_SYMLOOP_MAX           SYMBOLIC(_POSIX_SYMLOOP_MAX)
#define _POSIX_THREADS               SYMBOLIC(_POSIX_THREADS)
#define _POSIX_THREAD_ATTR_STACKADDR SYMBOLIC(_POSIX_THREAD_ATTR_STACKADDR)
#define _POSIX_THREAD_ATTR_STACKSIZE SYMBOLIC(_POSIX_THREAD_ATTR_STACKSIZE)
#define _POSIX_THREAD_CPUTIME        SYMBOLIC(_POSIX_THREAD_CPUTIME)
#define _POSIX_THREAD_DESTRUCTOR_ITERATIONS \
  SYMBOLIC(_POSIX_THREAD_DESTRUCTOR_ITERATIONS)
#define _POSIX_THREAD_KEYS_MAX SYMBOLIC(_POSIX_THREAD_KEYS_MAX)
#define _POSIX_THREAD_PRIORITY_SCHEDULING \
  SYMBOLIC(_POSIX_THREAD_PRIORITY_SCHEDULING)
#define _POSIX_THREAD_PROCESS_SHARED SYMBOLIC(_POSIX_THREAD_PROCESS_SHARED)
#define _POSIX_THREAD_SAFE_FUNCTIONS SYMBOLIC(_POSIX_THREAD_SAFE_FUNCTIONS)
#define _POSIX_THREAD_THREADS_MAX    SYMBOLIC(_POSIX_THREAD_THREADS_MAX)
#define _POSIX_TIMEOUTS              SYMBOLIC(_POSIX_TIMEOUTS)
#define _POSIX_TIMERS                SYMBOLIC(_POSIX_TIMERS)
#define _POSIX_TIMER_MAX             SYMBOLIC(_POSIX_TIMER_MAX)
#define _POSIX_TRACE_EVENT_NAME_MAX  SYMBOLIC(_POSIX_TRACE_EVENT_NAME_MAX)
#define _POSIX_TRACE_NAME_MAX        SYMBOLIC(_POSIX_TRACE_NAME_MAX)
#define _POSIX_TRACE_SYS_MAX         SYMBOLIC(_POSIX_TRACE_SYS_MAX)
#define _POSIX_TRACE_USER_EVENT_MAX  SYMBOLIC(_POSIX_TRACE_USER_EVENT_MAX)
#define _POSIX_TTY_NAME_MAX          SYMBOLIC(_POSIX_TTY_NAME_MAX)
#define _POSIX_TZNAME_MAX            SYMBOLIC(_POSIX_TZNAME_MAX)
#define _POSIX_V6_LP64_OFF64         SYMBOLIC(_POSIX_V6_LP64_OFF64)
#define _POSIX_V7_LP64_OFF64         SYMBOLIC(_POSIX_V7_LP64_OFF64)
#define _POSIX_VDISABLE              SYMBOLIC(_POSIX_VDISABLE)
#define _POSIX_VERSION               SYMBOLIC(_POSIX_VERSION)

#endif /* COSMOPOLITAN_LIBC_SYSV_CONSTS__POSIX_H_ */
